<?php

namespace Netzmacher\Browser\Utility\UserFunc;

/* * *************************************************************
 *  Copyright notice
 *
 *  (c) 2010-2019 - Dirk Wildt <http://wildt.at.die-netzmacher.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************* */

/**
 * Class provides methods for the extension manager.
 *
 * @author    Dirk Wildt <http://wildt.at.die-netzmacher.de>
 * @package    TYPO3
 * @subpackage    browser
 * @version 9.3.3
 * @since 9.3.3
 */
class CObj
{

	/**
	 * Constructor. The method initiate the parent object
	 *
	 * @param	object		The parent object
	 * @return	void
	 */
	public function __construct( $pObj )
	{
		$this->pObj = $pObj;
	}

	/**
	 * Renders a cObject, if configuration is given
	 *
	 * 
	 * @return	string		message wrapped in HTML
	 * @version 9.3.3
	 * @since 9.3.3
	 */
	public function GetSingle( $name, $conf)
	{
		if(!is_array($conf)){
			return $name;
		}

		return $this->pObj->cObj->cObjGetSingle( $name, $conf );
	}

}
